#include <iostream>
#include <vector>

using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data() {
    size_t number_count;
    Input in;

    cerr << "Enter number count: ";
    cin >> number_count;
    vector<double> numbers(number_count);

    in.numbers.resize(number_count);

    for (size_t i = 0; i < number_count; i++) {
        cin >> in.numbers[i];
    }

    cerr << "Enter bins count: ";
    cin >> in.bin_count;
    return in;
}

void
    find_minmax(const vector<double>& numbers, double& min, double& max) {
    min = numbers[0];
    max = numbers[0];
    // (     )
    for (double value : numbers)
    {
        if (value < min) {min = value;}
        else if (value > max) {max = value;}
    }
}

vector<size_t>
make_histogram(const vector<double>& numbers, size_t& bin_count)
{
    double min, max;
    find_minmax(numbers, min, max);

    double bin_size = (max - min) / bin_count;
    vector<size_t> bins(bin_count);
    for (size_t i = 0; i < numbers.size(); i++)
    {
        for (size_t j = i + 1; j < numbers.size(); j++)
        {
            if (numbers[i] == numbers[j])
            {
                //numbers.erase(numbers.begin() + j);
                //number_count--;
                //i--;
                //cout << "Removed number " << numbers[j] << endl;
            }
        }
    }

    for (size_t i = 0; i < numbers.size(); i++)
    {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
                auto low_bound = min + j * bin_size;
                auto high_bound = min + (j + 1) * bin_size;
                if ((low_bound <= numbers[i]) && (numbers[i] < high_bound))
                {
                    bins[j]++;
                    found = true;
                }
        }

        if (!found)
        {
            bins[bin_count - 1]++;
        }
    }

    return bins;
}

void
show_histogram_text(const vector<size_t>& bins, size_t& bin_count) {
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
    size_t max_count = 0;

    for (size_t s = 0; s < bin_count; s++)
    {
        if (bins[s] > max_count)
        {
            max_count = bins[s];
        }
    }

    for (size_t bin : bins)
    {
        if (bin < 100) cout << " ";
        if (bin < 10) cout << " ";
        cout << bin;
        cout << "|";
        size_t height = MAX_ASTERISK * (static_cast<double>(bin) / max_count);
        if (max_count <= MAX_ASTERISK) height = bin;
        for (size_t i = 0; i < height; i++) cout << "*";
        cout << endl;
    }
}

int main()
{
    Input in = input_data();
    vector<size_t> bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_text(bins, in.bin_count);
}
